## squashfs-tools 4.7.2

=== squashfs-tools/Makefile ===
# Squashfs-tools 4.7.2 release
RELEASE_VERSION = 4.7.2
RELEASE_DATE = 2025/08/18
###############################################
#                Build options                #
###############################################
#
# Edit the following definitions to customise the build, or run
# "CONFIG=1 make" with the build options below to customise the build on
# the command line.
#
ifndef CONFIG
###############################################
#            Compression algorithms           #
###############################################
#
# All of the compression algorithms (gzip, lzo, lz4, xz and zstd) are
# by default selected to be built.
#
# To unselect an algorithm comment out the XXX_SUPPORT = 1 line.
#
# Obviously you may need to install the compression algorithm devel
# packages, otherwise the build will fail.
#
############# Building gzip support ###########
#
# The compression type default (COMP_DEFAULT) is gzip.
#
# If you don't want/need gzip support then comment out the GZIP SUPPORT line
# below, and change COMP_DEFAULT to one of the compression types you have
# selected.
#
# Obviously at least one of the compression types must be built and selected
# as the default compression type.
#
GZIP_SUPPORT = 1

########### Building XZ support #############
#
# LZMA2 compression.
#
# XZ Utils liblzma (https://tukaani.org/xz/) is supported
#
# Development packages (libraries and header files) should be
# supported by most modern distributions.  Please refer to
# your distribution package manager.
#
# To skip building ZX support comment out the line below.
XZ_SUPPORT = 1

# Enable support for OpenWrt extended compression options by uncommenting
# next line.  Do not do this unless you understand the implications.
#XZ_EXTENDED_OPTIONS = 1


############ Building LZO support ##############
#
# The LZO library (http://www.oberhumer.com/opensource/lzo/) is supported.
#
# Development packages (libraries and header files) should be
# supported by most modern distributions.  Please refer to
# your distribution package manager.
#
# To skip building LZO support comment out the line below.
LZO_SUPPORT = 1


########### Building LZ4 support #############
#
# Yann Collet's LZ4 tools are supported
# LZ4 homepage: https://lz4.github.io/lz4/
# LZ4 source repository: https://github.com/lz4/lz4/
#
# Development packages (libraries and header files) should be
# supported by most modern distributions.  Please refer to
# your distribution package manager.
#
# To skip building LZ4 support comment out the line below.
LZ4_SUPPORT = 1


########### Building ZSTD support ############
#
# The ZSTD library is supported
# ZSTD homepage: https://facebook.github.io/zstd/
# ZSTD source repository: https://github.com/facebook/zstd
#
# Development packages (libraries and header files) should be
# supported by most modern distributions.  Please refer to
# your distribution package manager.
#
# To skip building ZSTD support comment out the line below.
ZSTD_SUPPORT = 1


######## Specifying default compression ########
#
# The next line specifies which compression algorithm is used by default
# in Mksquashfs.  Obviously the compression algorithm must have been
# selected to be built
#
COMP_DEFAULT = gzip


###############################################
#  Extended attribute (XATTRs) build options  #
###############################################
#
# Building XATTR support for Squashfs tools.
#
# If you don't want to read, write or store XATTRs in Squashfs
# filesystems, then comment out the next definition.  Generally
# speaking you want to define this option even if your C library
# or operating system doesn't support XATTRs, because this option
# contains support to add XATTRs to the Squashfs filesystem
# on the command line, via actions and input and output them via
# pseudo-files etc. which is independent of library/OS support.
XATTR_SUPPORT = 1

# If your C library or operating system doesn't support XATTRs then
# this definition is the one you should comment out.  Commenting
# this out will not build code to read XATTRs from the source filesystem
# or write XATTRs to the target filesystem.
XATTR_OS_SUPPORT = 1

# Select whether you wish xattrs to be stored by Mksquashfs and extracted
# by Unsquashfs by default.  If selected users can disable xattr support by
# using the -no-xattrs option
#
# If unselected, Mksquashfs/Unsquashfs won't store and extract xattrs by
# default.  Users can enable xattrs by using the -xattrs option.
XATTR_DEFAULT = 1


###############################################
#       Parallel reader thread options        #
###############################################
#
# Select how many reader threads are enabled by default.  The options are:
#
# 1. A single reader thread, as was traditionally used in Mksquashfs.  This
#    is the lowest performing and most conservative option.
#
# 2. The default number of small reader threads and block reader threads given
#    here.  These values are intended to give a peformance boost on media
#    that will benefit from parallel reads (e.g. modern SSD drives), but not
#    affect performance on other media that won't benefit from parallel reads.
#
# 3. A custom default setting of small reader threads and block reader threads.
#    The higher the number of threads the greater the performance boost on
#    filesystems with lots of small files, and/or media that benefits from
#    a high amount of parallelism such as network filesystems.
#
# Uncomment next line to use a single reader thread
#SINGLE_READER_THREAD = 1
SMALL_READER_THREADS = 4
BLOCK_READER_THREADS = 4

###############################################
#               Manpage generation            #
###############################################
#
# If help2man is available on the system, on installation, the Makefile
# will try to generate "custom" manpages from the built squashfs-tools.
#
# If the squashfs-tools have been cross-compiled, or for any other
# reason they're not executable, this will generate errors at
# installation and the install script will fall back to using
# pre-built manpages.
#
# Change next variable to "y" to use the pre-built manpages by default,
# and not attempt to generate "custom" manpages.  This will eliminate
# errors and warnings at install time.
USE_PREBUILT_MANPAGES = n

###############################################
#              INSTALL PATHS                  #
###############################################
#
# Alter INSTALL_* to install binaries and manpages
# elsewhere.
#
# To skip building and installing manpages,
# unset INSTALL_MANPAGES_DIR or set to ""
#
INSTALL_PREFIX = /usr/local
INSTALL_DIR = $(INSTALL_PREFIX)/bin
INSTALL_MANPAGES_DIR = $(INSTALL_PREFIX)/man/man1

###############################################
#             __ATOMIC_EXCHANGE_N             #
###############################################
#
# Mksquashfs uses a GCC builtin (also supported by Clang)
# __atomic_exchange_n() to do lockless thread synchronisation.
# If this is unavailable on your compiler, uncomment
# the line below to use a (slower) Pthread mutex.
#DONT_USE_ATOMIC_EXCHANGE_N = 1

###############################################
#              Obsolete options               #
###############################################

########### Building LZMA support #############
#
# LZMA1 compression.
#
# LZMA1 compression is obsolete, and the newer and better XZ (LZMA2)
# compression should be used in preference.
#
# Both XZ Utils liblzma (https://tukaani.org/xz/) and LZMA SDK
# (http://www.7-zip.org/sdk.html) are supported
#
# To build using XZ Utils liblzma - install the library and uncomment
# the LZMA_XZ_SUPPORT line below.
#
# To build using the LZMA SDK (4.65 used in development, other versions may
# work) - download and unpack it, uncomment and set LZMA_DIR to unpacked source,
# and uncomment the LZMA_SUPPORT line below.
#
#LZMA_XZ_SUPPORT = 1
#LZMA_SUPPORT = 1
#LZMA_DIR = ../../../../LZMA/lzma465
else
GZIP_SUPPORT ?= 1
XZ_SUPPORT ?= 1
LZO_SUPPORT ?= 1
LZ4_SUPPORT ?= 1
ZSTD_SUPPORT ?= 1
COMP_DEFAULT ?= gzip
XATTR_SUPPORT ?= 1
XATTR_OS_SUPPORT ?= 1
XATTR_DEFAULT ?= 1
USE_PREBUILT_MANPAGES ?= n
INSTALL_PREFIX ?= /usr/local
INSTALL_DIR ?= $(INSTALL_PREFIX)/bin
INSTALL_MANPAGES_DIR ?= $(INSTALL_PREFIX)/man/man1
LZMA_XZ_SUPPORT ?= 0
LZMA_SUPPORT ?= 0
LZMA_DIR ?= ../../../../LZMA/lzma465
XZ_EXTENDED_OPTIONS ?= 0
DONT_USE_ATOMIC_EXCHANGE_N ?= 0
SINGLE_READER_THREAD ?= 0
SMALL_READER_THREADS ?= 8
BLOCK_READER_THREADS ?= 3
endif


###############################################
#        End of BUILD options section         #
###############################################
#
INCLUDEDIR = -I.

MKSQUASHFS_OBJS = mksquashfs.o read_fs.o action.o swap.o pseudo.o compressor.o \
	sort.o progressbar.o info.o restore.o process_fragments.o \
	caches-queues-lists.o reader.o tar.o date.o memory.o mksquashfs_help.o \
	print_pager.o symbolic_mode.o thread.o nprocessors_compat.o limit.o \
	virt_disk_pos.o

UNSQUASHFS_OBJS = unsquashfs.o unsquash-1.o unsquash-2.o unsquash-3.o \
	unsquash-4.o unsquash-123.o unsquash-34.o unsquash-1234.o unsquash-12.o \
	swap.o compressor.o unsquashfs_info.o date.o memory.o print_pager.o \
	unsquashfs_help.o nprocessors_compat.o limit.o

CFLAGS ?= -O2
CFLAGS += $(EXTRA_CFLAGS) $(INCLUDEDIR) -D_FILE_OFFSET_BITS=64 \
	-D_LARGEFILE_SOURCE -D_GNU_SOURCE -DCOMP_DEFAULT=\"$(COMP_DEFAULT)\" \
	-Wall

LIBS = -lpthread -lm
ifeq ($(GZIP_SUPPORT),1)
CFLAGS += -DGZIP_SUPPORT
MKSQUASHFS_OBJS += gzip_wrapper.o
UNSQUASHFS_OBJS += gzip_wrapper.o
LIBS += -lz
ifeq ($(COMP_DEFAULT),gzip)
COMPRESSORS += gzip@(default)
else
COMPRESSORS += gzip
endif
endif

ifeq ($(LZO_SUPPORT),1)
CFLAGS += -DLZO_SUPPORT
MKSQUASHFS_OBJS += lzo_wrapper.o
UNSQUASHFS_OBJS += lzo_wrapper.o
LIBS += -llzo2
ifeq ($(COMP_DEFAULT),lzo)
COMPRESSORS += lzo@(default)
else
COMPRESSORS += lzo
endif
endif

ifeq ($(LZ4_SUPPORT),1)
CFLAGS += -DLZ4_SUPPORT
MKSQUASHFS_OBJS += lz4_wrapper.o
UNSQUASHFS_OBJS += lz4_wrapper.o
LIBS += -llz4
ifeq ($(COMP_DEFAULT),lz4)
COMPRESSORS += lz4@(default)
else
COMPRESSORS += lz4
endif
endif

ifeq ($(XZ_SUPPORT),1)
CFLAGS += -DXZ_SUPPORT
ifeq ($(XZ_EXTENDED_OPTIONS),1)
MKSQUASHFS_OBJS += xz_wrapper_extended.o
UNSQUASHFS_OBJS += xz_wrapper_extended.o
else
MKSQUASHFS_OBJS += xz_wrapper.o
UNSQUASHFS_OBJS += xz_wrapper.o
endif
LIBS += -llzma
ifeq ($(COMP_DEFAULT),xz)
COMPRESSORS += xz@(default)
else
COMPRESSORS +=xz
endif
endif

ifeq ($(ZSTD_SUPPORT),1)
CFLAGS += -DZSTD_SUPPORT
MKSQUASHFS_OBJS += zstd_wrapper.o
UNSQUASHFS_OBJS += zstd_wrapper.o
LIBS += -lzstd
ifeq ($(COMP_DEFAULT),zstd)
COMPRESSORS += zstd@(default)
else
COMPRESSORS += zstd
endif
endif

ifeq ($(LZMA_SUPPORT),1)
LZMA_OBJS = $(LZMA_DIR)/C/Alloc.o $(LZMA_DIR)/C/LzFind.o \
	$(LZMA_DIR)/C/LzmaDec.o $(LZMA_DIR)/C/LzmaEnc.o $(LZMA_DIR)/C/LzmaLib.o
INCLUDEDIR += -I$(LZMA_DIR)/C
CFLAGS += -DLZMA_SUPPORT
MKSQUASHFS_OBJS += lzma_wrapper.o $(LZMA_OBJS)
UNSQUASHFS_OBJS += lzma_wrapper.o $(LZMA_OBJS)
ifeq ($(COMP_DEFAULT),lzma)
COMPRESSORS += lzma@(default)
else
COMPRESSORS += lzma
endif
endif

ifeq ($(LZMA_XZ_SUPPORT),1)
CFLAGS += -DLZMA_SUPPORT
MKSQUASHFS_OBJS += lzma_xz_wrapper.o
UNSQUASHFS_OBJS += lzma_xz_wrapper.o
LIBS += -llzma
ifeq ($(COMP_DEFAULT),lzma)
COMPRESSORS += lzma@(default)
else
COMPRESSORS += lzma
endif
endif

ifeq ($(XATTR_SUPPORT),1)
ifeq ($(XATTR_DEFAULT),1)
CFLAGS += -DXATTR_SUPPORT -DXATTR_DEFAULT
else
CFLAGS += -DXATTR_SUPPORT
endif
ifeq ($(XATTR_OS_SUPPORT),1)
CFLAGS += -DXATTR_OS_SUPPORT
MKSQUASHFS_OBJS += xattr.o read_xattrs.o tar_xattr.o pseudo_xattr.o xattr_system.o
UNSQUASHFS_OBJS += read_xattrs.o unsquashfs_xattr.o unsquashfs_xattr_system.o
else
MKSQUASHFS_OBJS += xattr.o read_xattrs.o tar_xattr.o pseudo_xattr.o
UNSQUASHFS_OBJS += read_xattrs.o unsquashfs_xattr.o
endif
endif

ifeq ($(DONT_USE_ATOMIC_EXCHANGE_N),1)
CFLAGS += -DDONT_USE_ATOMIC_EXCHANGE_N
endif

MAX_READER_THREADS=1024
CFLAGS+= -DMAX_READER_THREADS=$(MAX_READER_THREADS)

ifeq ($(SINGLE_READER_THREAD),1)

=== debian/changelog ===
squashfs-tools (1:4.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 20 Aug 2025 12:23:17 +0200

=== debian/control ===
Source: squashfs-tools
Section: kernel
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends:
 debhelper-compat (= 13), libattr1-dev, liblzma-dev, liblzo2-dev, liblz4-dev, zlib1g-dev, libzstd-dev, help2man
Standards-Version: 4.7.2
Homepage: https://github.com/plougher/squashfs-tools

Package: squashfs-tools
Architecture: linux-any kfreebsd-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tool to create and append to squashfs filesystems
 Squashfs is a highly compressed read-only filesystem for Linux. It uses zlib
 compression to compress both files, inodes and directories. Inodes in the
 system are very small and all blocks are packed to minimise data overhead.
 Block sizes greater than 4K are supported up to a maximum of 64K.
 .
 Squashfs is intended for general read-only filesystem use, for archival use
 (i.e. in cases where a .tar.gz file may be used), and in constrained block
 device/memory systems (e.g. embedded systems) where low overhead is needed.

=== debian/watch ===
version=4
opts=uversionmangle=s/^(SNAPSHOT|RELEASE)\.//;s/(\d+)[_-](\d+)[_-](\d+)/\$1.\$2.\$3/;s/(\d+)[_-](\d+)/\$1.\$2/;s/(\d)[_\.\-\+]?((rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/;s/(\d)[_\.\-\+]?RC[\-\.]?(\d*)$/$1~rc$2/,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//i \
https://github.com/plougher/squashfs-tools/tags .*/[vV]?(\d\S*)@ARCHIVE_EXT@

## squashfs-tools 4.7.4

=== squashfs-tools/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-# Squashfs-tools 4.7.2 release
-RELEASE_VERSION = 4.7.2
-RELEASE_DATE = 2025/08/18
+# Squashfs-tools 4.7.4 release
+RELEASE_VERSION = 4.7.4
+RELEASE_DATE = 2025/11/09
 ###############################################
 #                Build options                #
 ###############################################

=== debian/changelog ===
squashfs-tools (1:4.7.4-1) unstable; urgency=medium

  * New upstream release.
  * Update watch file.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 10 Nov 2025 07:04:26 +0100

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_CFLAGS_MAINT_APPEND = -fgnu89-inline

override_dh_auto_configure:
	dh_auto_configure -- $(shell dpkg-buildflags --export=cmdline)

override_dh_auto_build:
	LZMA_XZ_SUPPORT=1 LZ4_SUPPORT=1 LZO_SUPPORT=1 XZ_SUPPORT=1 \
			ZSTD_SUPPORT=1 dh_auto_build

override_dh_auto_install:
	dh_auto_install -- \
		INSTALL_DIR=$(CURDIR)/debian/squashfs-tools/usr/bin \
		INSTALL_MANPAGES_DIR=$(CURDIR)/debian/squashfs-tools/usr/share/man/man1

%:
	dh ${@} --sourcedirectory=squashfs-tools/

.PHONY: override_dh_auto_build override_dh_auto_install

=== debian/watch ===
Version: 5

Template: Github
Owner: plougher
Project: squashfs-tools
Matching-Pattern: tags/(\d\.[\d\.]*)
